from axelrod.action import Action
from axelrod.player import Player
IllIllIIllI, IlIlllllIlllIllIlI = Action.C, Action.D
class IlllllIIIllIIIllllI(Player):
    IIllllllI = "strategy"
    IlIlllIIIlIlIIIl = {
        "memory_depth": 0,  
        "stochastic": True,
        "long_run_time": False,
        "inspects_source": False,
        "manipulates_source": False,
        "manipulates_state": False,
    }
    def __init__(llIlllllIllIlllIIlIl, lIllIlIlllIlIllI: float = 0.5) -> None:
        super().__init__()
        llIlllllIllIlllIIlIl.lIllIlIlllIlIllI = lIllIlIlllIlIllI
    def llIIIIIlllIllIIlIIl(llIlllllIllIlllIIlIl, IlIIIIllll: Player) -> Action:
        return llIlllllIllIlllIIlIl._random.random_choice(llIlllllIllIlllIIlIl.lIllIlIlllIlIllI)
    def IIlIIlIIlIIlII(llIlllllIllIlllIIlIl):
        super().IIlIIlIIlIIlII()
        if llIlllllIllIlllIIlIl.lIllIlIlllIlIllI in [0, 1]:
            llIlllllIllIlllIIlIl.IlIlllIIIlIlIIIl["stochastic"] = False
        if llIlllllIllIlllIIlIl.lIllIlIlllIlIllI <= 0:
            llIlllllIllIlllIIlIl.llIIIIIlllIllIIlIIl = llIlllllIllIlllIIlIl.lllIIIllIIIII
        if llIlllllIllIlllIIlIl.lIllIlIlllIlIllI >= 1:
            llIlllllIllIlllIIlIl.llIIIIIlllIllIIlIIl = llIlllllIllIlllIIlIl.lllllIlllllll
    @classmethod
    def lllllIlllllll(lIlIlIlIllIll, IlIIIIllll: Player) -> Action:
        return IllIllIIllI
    @classmethod
    def lllIIIllIIIII(lIlIlIlIllIll, IlIIIIllll: Player) -> Action:
        return IlIlllllIlllIllIlI